#include <Wire.h>
#include <Bricktronics.h>
Bricktronics brick = Bricktronics();
Motor m1 = Motor(&brick, 1);
Motor m2 = Motor(&brick, 2);
Ultrasonic ultra = Ultrasonic(&brick, 4);
Button b1 = Button(&brick, 1);
Button b2 = Button(&brick, 2);
ColorSensor color = ColorSensor(&brick, 3);
int state = 0;
int directio = 0;
int mark = 0;

void setup() 
{
  brick.begin();
  m1.begin();
  m2.begin();
  b1.begin();
  b2.begin();
  color.begin();
  ultra.begin();
  Serial.begin(115200);
}

void loop() 
{
  Serial.print("Distance: ");
  Serial.println(ultra.getDistance());
  int distance = ultra.getDistance();
  Serial.print("Color: ");
  Serial.println(color.get_color());
  int light = color.get_color();
  Serial.print("Mark: ");
  Serial.println(mark);
  //Serial.println(directio);
  if (light > 4)
  {
    m2.set_speed(80);
  }
  else if (b2.is_pressed())
  {
    m2.set_speed(80);
    directio = 1;
    mark = 1;
  }
  else if (b1.is_pressed())
  {
    m2.set_speed(-80);
    directio = 2;
    mark = 1;
  }
  if (distance < 30) 
  {
    if (directio == 1)
    {
      m2.set_speed(-80);
      delay(100);
      m2.stop();
      m1.set_speed(255);
      delay(500);
      m1.stop(); 
      if (directio == 1)
      {
        m2.set_speed(80);
      }
      else if (directio == 2)
      {
        m2.set_speed(-80);
      }
      else if (directio == 0)
      {
        m2.set_speed(80);
      }
    }
    if (directio == 2)
    {
      m2.set_speed(80);
      delay(100);
      m2.stop();
      m1.set_speed(255);
      delay(500);
      m1.stop(); 
      if (directio == 1)
      {
        m2.set_speed(80);
      }
      else if (directio == 2)
      {
        m2.set_speed(-80);
      }
      else if (directio == 0)
      {
        m2.set_speed(80);
      }
    }
    if (directio == 0)
    {
      m2.stop();
      m1.set_speed(255);
      delay(700);
      m1.stop(); 
      if (directio == 1)
      {
        m2.set_speed(80);
      }
      else if (directio == 2)
      {
        m2.set_speed(-80);
      }
      else if (directio == 0)
      {
        m2.set_speed(80);
      }
    }
  } 
  if ((mark == 1) && (light > 4))
  {
    Serial.println(mark);
    m2.stop();
    exit(0);
  }
  else
  {
  }
}
